## NAME

r.sunmask - Calculates cast shadow areas from sun position and DEM. Either A: exact sun position is specified, or B: date/time to calculate the sun position by r.sunmask itself.

## KEYWORDS

raster

## SYNOPSIS

r.sunmask
r.sunmask help
r.sunmask [-zvsg] elev=string output=string [altitude=float] [azimuth=float] [year=integer] [month=integer] [day=integer] [hour=integer] [minute=integer] [second=integer] [timezone=integer] [east=value] [north=value] [--overwrite]

### Flags:

-z
  Zero is a real elevation
-v
  verbose output (also print out sun position etc.)
-s
  calculate sun position only and exit
-g
  Print the sun position output in shell script style
--overwrite
  Force overwrite of output files

### Parameters:

elev=string
  Name of elevation raster map
output=string
  Output raster map having shadows
altitude=float
  A: altitude of the sun above horizon, degrees
  Options: 0-89.999
azimuth=float
  A: azimuth of the sun from the north, degrees
  Options: 0-360
year=integer
  B: year (1950..2050)
month=integer
  B: month (0..12)
day=integer
  B: day (0..31)
hour=integer
  B: hour (0..24)
minute=integer
  B: minutes (0..60)
second=integer
  B: seconds (0..60)
timezone=integer
  B: timezone (east positive, offset from GMT, also use to adjust daylight savings)
east=value
  east coordinate (point of interest, default: map center)
north=value
  north coordinate (point of interest, default: map center)

## DESCRIPTION

r.sunmask creates an output map layer based on an input elevation raster map layer and the sun position. The output map layer contains the cast shadow areas arising from sun shine and elevations. The user can define the sun position either directly or the module calculates it from given location and date/time parameters using the NREL sun position algorithm. So either "A:"-parameters to specify the exact known sun position or "B:-parameters" to specify date/time for sun position calculation by r.sunmask itself have to be used.

The module performs sunset/sunrise checks and refraction correction for sun position calculation. Local coordinate systems are internally transformed to latitude/longitude for the SOLPOS algorithm. The elevation is not considered in the sunset/sunrise calculations.

## Notes

r.sunmask and daylight savings: Rather than convert time to GMT, the solpos algorithm uses what is called Local Standard Time, which is generally defined politically as an offset from GMT. So the key is the offset from GMT, which the solpos Time Zone parameter. If the user specifies clock time (different for winter and summer), he/she would have to change the Time Zone parameter seasonally in r.sunmask (timezone parameter).

Note: In latitude/longitude locations the position coordinates pair (east/west) has to be specified in decimal degree (not D:M:S). If not specified, the map center's coordinates will be used. Also g.region -l displays the map center's coordinates.

Note for module usage with -g flag and calculations close to sunset/sunrise:

     [...]
     sunangleabovehorizont=0.434240
     sunrise=07:59:19
     sunset=16:25:17
     Time (07:59:02) is before sunrise (07:59:19)!
     WARNING: Nothing to calculate. Please verify settings.
     No map calculation requested. Finished.

In above calculation appears to be a mistake as the program indicates that we are before sunrise while the sun angle above horizon is already positive. The reason is that sun angle above horizon is calculated with correction for atmosphere refraction while sunrise and sunset are calculated without correction for atmosphere refraction. The output without -g flag contains related indications.

## Acknowledgements

Acknowledgements: National Renewable Energy Laboratory for their SOLPOS 2.0 sun position algorithm.

## SEE ALSO

g.region, r.sun, r.slope.aspect

## AUTHOR

Janne Soimasuo, Finland 1994
update to FP by Huidae Cho 2001
added solpos algorithm feature by Markus Neteler 2001

Last changed: $Date: 2004/12/07 16:12:41 $

Main index - raster index - Full index